{-# LANGUAGE StandaloneKindSignatures #-}
{-# LANGUAGE RoleAnnotations #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}

{-# OPTIONS_GHC -Wno-unsafe #-}
{-# OPTIONS_GHC -Wno-missing-safe-haskell-mode #-}
{-# OPTIONS_GHC -Wno-unused-top-binds #-}

module GHC.Generics.Coerce.Example
()
where

import Prelude (Show)

import GHC.Generics (Generic)
import GHC.Generics.Coerce (genericCoerce)

import Data.Int (Int)
import Data.Kind (Type)


type Pair :: Type -> Type -> Type
type role Pair representational representational

data Pair a b = Pair a b
  deriving stock (Generic, Show)

tupleCoerce :: Pair a b -> (a, b)
tupleCoerce = genericCoerce

-- >>> tupleCoerce (Pair 1 1)
-- (1,1)


type IntPair :: Type
data IntPair = IntPair Int Int
  deriving stock (Generic, Show)

intTupleCoerce :: IntPair -> Pair Int Int
intTupleCoerce = genericCoerce

-- >>> intTupleCoerce (IntPair 1 2)
-- Pair 1 2

