{-# LANGUAGE Unsafe #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingVia #-}
{-# LANGUAGE TypeOperators #-}

{-# OPTIONS_GHC -Wno-unsafe #-}
{-# LANGUAGE StandaloneKindSignatures #-}

module GHC.Generics.CoerceTo.Example () where

import Prelude ()

import GHC.Generics (Generic)
import GHC.Generics.CoerceTo ( GenericCoerceTo(GenericCoerceTo) )

import Data.Kind (Type)

import Data.Semigroup (Semigroup)
import Data.Monoid (Sum(Sum))
import Data.Int (Int)
import Text.Show (Show)

type IntPair :: Type

data IntPair = IntPair Int Int
  deriving stock (Generic, Show)
  deriving (Semigroup) via (IntPair `GenericCoerceTo` (Sum Int, Sum Int))

-- >>> IntPair 1 1 <> IntPair 1 1
-- IntPair 2 2

